
import "JackdawPlugins.Reloader.functions"

--Slash Commands

	ReloadCommand = Turbine.ShellCommand()
	function ReloadCommand:Execute(command, arguments)
	
		--HELP!
		if arguments=="help" then
			Turbine.Shell.WriteLine("Reloader loads, unloads or reloads plugins.")
			Turbine.Shell.WriteLine("/rl or /reload are the same.")
			Turbine.Shell.WriteLine("/rl on its own to reload all plugins.")
			Turbine.Shell.WriteLine("/rl button to show or hide the reloader button.")
			Turbine.Shell.WriteLine("Note: You need to install DeusDictums Dragbar to use the button.")
			Turbine.Shell.WriteLine("/rl unload=PLUGIN NAME to reload all plugins EXCEPT that one. The name must be perfect.")
			return
		end
		
		--Show or hide the button
		if arguments=="button" or arguments=="Button" then
			ButtonShown=not (ButtonShown)
			ShowButton ()
			return
		end
		
		--No argument? Then just reload all
		if arguments=="" then
			reload()
			return
		end
		
		--If we get here then the argument is, possibly, to unload a specific plugin.
		local t=string.find(string.upper(arguments), "UNLOAD=")
		if t==nil then Turbine.Shell.WriteLine("Something wrong with the argument? /rl help for help") end
		
		reload(string.sub(arguments,t+7))
	end
	Turbine.Shell.AddCommand('reload;rl', ReloadCommand)

--Load Data
	ButtonData=Turbine.PluginData.Load( Turbine.DataScope.Character, "Reloader" )

	if ButtonData~=nil then ButtonShown=ButtonData.ButtonShown end
	if ButtonShown then ShowButton() end

--Save Data
	Plugins["Reloader"].Unload = function( sender, args )
		ButtonData.ButtonShown=ButtonShown
		Turbine.PluginData.Save( Turbine.DataScope.Character, "Reloader", ButtonData )
	end